/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.8
        Device            :  PIC16F1827
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"

unsigned char tx_data[8];
unsigned char ScnStatus; //40 kHz: set 0th bit to 1
//33 kHz: set 1st bit to 1
//38 kHz: clear 0th and 1st bits to 0
//sharp mode: set 2nd bit to 1
unsigned char rmcbyt; // Bytes for sending data
unsigned char rmcbit; // Additionl bits for sending data
unsigned char start_h; // leader on time
unsigned char start_l; // leader off time
unsigned char data_0h; // data 0 on time
unsigned char data_1h; // data 1 on time
unsigned char data_0l; // data 0 off time
unsigned char data_1l; // data 1 off time
unsigned char stop_h; // stop on time
unsigned char rptwait_bf; //repeat wait time for sharp mode
unsigned char rptwait; // repeat wait time for sharp mode


extern void transmit(void); // assembly routine 
void Toshiba(void);
void KeySense(void);

/*
                         Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    //INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();
    
    Toshiba(); //set toshiba mode

    while (1) {
        SLEEP();
        DELAY_milliseconds(50); //removal of chattering
        KeySense();
    }
}


//NEC format
//   ________     _   _   _   _   _   _   _    _                             _
//__|        |___| |_| |_| |_| |_| |_| |_| |__| |_| ---------------------   | |____________
//   Leader code  0   0   0   0   0   0   1    0                           STOP
//   90       45  6 6 6 6 6 6 6 6 6 6 6 6 6 12 6 6                           6   (x 0.1 msec)

void Toshiba(void) {
    ScnStatus = 0x00; //38kHz: Toshiba mode
    rmcbyt = 4;
    rmcbit = 0;
    start_h = 90;
    start_l = 42;
    data_0h = 7;
    data_1h = 7;
    data_0l = 5;
    data_1l = 16;
    stop_h = 7;
    rptwait_bf = 0;
    rptwait = 0;
}

void KeySense(void) {
    LATA = 0b11111110;
    if (IOCBFbits.IOCBF0 == 1 && PORTBbits.RB0 == 0) {
        //Toshiba TV Power ON/OFF
        tx_data[0] = 0x40;
        tx_data[1] = 0xbf;
        tx_data[2] = 0x12;
        tx_data[3] = 0xed;
        transmit(); //IR transmition
        while (PORTBbits.RB0 == 0); //wait for key release
        IOCBFbits.IOCBF0 = 0; //interruption enable again
    }
    if (IOCBFbits.IOCBF1 == 1 && PORTBbits.RB1 == 0) {
        //Toshiba TV Channel UP
        tx_data[0] = 0x40;
        tx_data[1] = 0xbf;
        tx_data[2] = 0x1b;
        tx_data[3] = 0xe4;
        transmit(); //IR transmition
        while (PORTBbits.RB1 == 0); //wait for key release
        IOCBFbits.IOCBF1 = 0; //interruption enable again
    } else if (IOCBFbits.IOCBF2 == 1 && PORTBbits.RB2 == 0) {
        //Toshiba TV Channel DOWN
        tx_data[0] = 0x40;
        tx_data[1] = 0xbf;
        tx_data[2] = 0x1f;
        tx_data[3] = 0xe0;
        transmit(); //IR transmition
        while (PORTBbits.RB2 == 0); //wait for key release
        IOCBFbits.IOCBF2 = 0; //interruption enable again
    } else if (IOCBFbits.IOCBF3 == 1 && PORTBbits.RB3 == 0) {
        //Toshiba TV Normal
        tx_data[0] = 0x40;
        tx_data[1] = 0xbf;
        tx_data[2] = 0x7a;
        tx_data[3] = 0x85;
        transmit(); //IR transmition
        while (PORTBbits.RB3 == 0); //wait for key release
        IOCBFbits.IOCBF3 = 0; //interruption enable again
    } else if (IOCBFbits.IOCBF4 == 1 && PORTBbits.RB4 == 0) {
        //Toshiba TV BS
        tx_data[0] = 0x40;
        tx_data[1] = 0xbf;
        tx_data[2] = 0x7c;
        tx_data[3] = 0x83;
        transmit(); //IR transmition
        while (PORTBbits.RB4 == 0); //wait for key release
        IOCBFbits.IOCBF4 = 0; //interruption enable again
    }
    PORTA = 0b11111101;
    if (IOCBFbits.IOCBF0 == 1 && PORTBbits.RB0 == 0) {
        //Onkyo Power ON/OFF and Sleep
        tx_data[0] = 0xd2;
        tx_data[1] = 0x6d;
        tx_data[2] = 0x04;
        tx_data[3] = 0xfb;
        transmit(); //IR transmition
        tx_data[0] = 0xd2;
        tx_data[1] = 0x6d;
        tx_data[2] = 0x5d;
        tx_data[3] = 0xa2;
        transmit(); //IR transmition
        while (PORTBbits.RB0 == 0); //wait for key release
        IOCBFbits.IOCBF0 = 0; //interruption enable again
    }
    if (IOCBFbits.IOCBF1 == 1 && PORTBbits.RB1 == 0) {
        //Onkyo AM P1
        tx_data[0] = 0xd2;
        tx_data[1] = 0x6d;
        tx_data[2] = 0x47;
        tx_data[3] = 0xb8;
        transmit(); //IR transmition
        tx_data[0] = 0xd2;
        tx_data[1] = 0x6d;
        tx_data[2] = 0xd5;
        tx_data[3] = 0x2a;
        transmit(); //IR transmition
        while (PORTBbits.RB1 == 0); //wait for key release
        IOCBFbits.IOCBF1 = 0; //interruption enable again
    } else if (IOCBFbits.IOCBF2 == 1 && PORTBbits.RB2 == 0) {
        //Onkyo AM P2
        tx_data[0] = 0xd2;
        tx_data[1] = 0x6d;
        tx_data[2] = 0x47;
        tx_data[3] = 0xb8;
        transmit(); //IR transmition
        tx_data[0] = 0xd2;
        tx_data[1] = 0x6d;
        tx_data[2] = 0xd6;
        tx_data[3] = 0x29;
        transmit(); //IR transmition
        while (PORTBbits.RB2 == 0); //wait for key release
        IOCBFbits.IOCBF2 = 0; //interruption enable again
    } else if (IOCBFbits.IOCBF3 == 1 && PORTBbits.RB3 == 0) {
        //Onkyo FM P1
        tx_data[0] = 0xd2;
        tx_data[1] = 0x6d;
        tx_data[2] = 0x46;
        tx_data[3] = 0xb9;
        transmit(); //IR transmition
        tx_data[0] = 0xd2;
        tx_data[1] = 0x6d;
        tx_data[2] = 0xd5;
        tx_data[3] = 0x2a;
        transmit(); //IR transmition
        while (PORTBbits.RB3 == 0); //wait for key release
        IOCBFbits.IOCBF3 = 0; //interruption enable again
    } else if (IOCBFbits.IOCBF4 == 1 && PORTBbits.RB4 == 0) {
        //Onkyo FM P2
        tx_data[0] = 0xd2;
        tx_data[1] = 0x6d;
        tx_data[2] = 0x46;
        tx_data[3] = 0xb9;
        transmit(); //IR transmition
        tx_data[0] = 0xd2;
        tx_data[1] = 0x6d;
        tx_data[2] = 0xd6;
        tx_data[3] = 0x29;
        transmit(); //IR transmition
        while (PORTBbits.RB4 == 0); //wait for key release
        IOCBFbits.IOCBF4 = 0; //interruption enable again
    }
    IOCIF = 0;
    PORTA = 0;
}

/**
 End of File
*/